Summary:        Character encodings in Perl
Name:           perl-Encode
Version:        3.19
Release:        4%{?dist}
License:        (GPL+ or Artistic) and Artistic 2.0 and UCD
URL:            https://metacpan.org/release/Encode
Source0:        https://cpan.metacpan.org/authors/id/D/DA/DANKOGAI/Encode-%{version}.tar.gz
BuildRequires:  gcc make findutils
BuildRequires:  perl-generators perl-interpreter perl-devel
BuildRequires:  perl(Config) perl(strict) perl(warnings)
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(File::Spec) perl(File::Spec::Functions)
# Run-time:
BuildRequires:  perl(bytes) perl(Carp) perl(constant)
BuildRequires:  perl(Exporter) >= 5.57
BuildRequires:  perl(File::Basename) perl(File::Find)
BuildRequires:  perl(Filter::Util::Call)
BuildRequires:  perl(Getopt::Long) perl(Getopt::Std)

BuildRequires:  perl(MIME::Base64) perl(overload)
BuildRequires:  perl(parent) >= 0.221

BuildRequires:  perl(re) perl(Storable) perl(utf8) perl(vars) perl(XSLoader)
# Tests:
BuildRequires:  perl(blib) perl(charnames) perl(Devel::Peek)
BuildRequires:  perl(File::Compare) perl(File::Copy) perl(File::Temp) perl(FileHandle)
BuildRequires:  perl(FindBin) perl(IO::Select) perl(IPC::Open3)
BuildRequires:  perl(lib) perl(open) perl(PerlIO::encoding) perl(Scalar::Util)
BuildRequires:  perl(Symbol) perl(Test::More) perl(Tie::Scalar)

Requires:       perl(parent) >= 0.221
Provides:       perl-encoding
%{?perl_default_filter}
%global __provides_exclude %{?__provides_exclude:%__provides_exclude|}^perl\\((Encode::ConfigLocal|MY)\\)
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\((Exporter|parent)\\)$

%description
The "Encode" module provides the interfaces between Perl's strings and the rest of the system.
Perl strings are sequences of characters.

See `perldoc Encode` for more details.


%package devel
Summary:        Perl Encode Module Generator
License:        (GPL+ or Artistic) and UCD
Requires:       %{name} = %{version}-%{release}
Requires:       perl(Encode)
Recommends:     perl-devel

%description devel
enc2xs builds a Perl extension for use by Encode from either Unicode Character
Mapping files (.ucm) or Tcl Encoding Files (.enc). You can use enc2xs to add
your own encoding to perl. No knowledge of XS is necessary.


%prep
%autosetup -n Encode-%{version}
# Help generators to recognize Perl scripts
for file in t/*.t t/*.pl; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!.*perl\b}{$Config{startperl}}' "${file}"
    chmod +x "${file}"
done


%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1 OPTIMIZE="%{optflags}"
%{make_build}


%install
%{make_install}
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} %{buildroot}/*


%check
export HARNESS_OPTIONS=j%{_smp_build_ncpus}
make test


%files
%doc AUTHORS Changes README
%{_bindir}/encguess
%{_bindir}/piconv
%{perl_vendorarch}/auto/*
%{perl_vendorarch}/encoding.pm
%{perl_vendorarch}/Encode*
%exclude %{perl_vendorarch}/Encode/*.e2x
%exclude %{perl_vendorarch}/Encode/encode.h
%{_mandir}/man1/encguess.*
%{_mandir}/man1/piconv.*
%{_mandir}/man3/Encode.*
%{_mandir}/man3/Encode::*
%{_mandir}/man3/encoding.3pm.gz


%files devel
%{_bindir}/enc2xs
%{_mandir}/man1/enc2xs.*
%{perl_vendorarch}/Encode/*.e2x
%{perl_vendorarch}/Encode/encode.h


%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.19-4
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.19-3
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.19-2
- Rebuilt for OpenCloudOS Stream 23.09

* Mon Jul 31 2023 Xiaojie Chen <jackxjchen@tencent.com> - 3.19-1
- Upgrade to upstream version 3.19
- Remove perl(MODULE_COMPAT) which will be generated by perl-generators >= 1.15

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.18-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.18-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Aug 03 2022 rockerzhu <rockerzhu@tencent.com> - 3.18-1
- Initial build
